#include <iostream>
#include <stddef.h>

using namespace std;

template <typename E>
class DLinkedList;

template <typename E>
class DNode { 
private: 
	E elem; 
	DNode* next;
	DNode* prev; 	
	friend class DLinkedList<E>; 
};

template <typename E>
class DLinkedList { 
public: 
	DLinkedList(){ 
		head = new DNode<E>;
		tail = new DNode<E>;
		head->next = tail;
		head->prev = NULL;
		tail->prev = head;
		tail->next = NULL;
	}

	bool empty() const{ return head->next == tail; }

	~DLinkedList(){ while (!empty())  remove(head->next); }

	void add(DNode<E>* right_place, const E& e) {  // add right before right_place in the list
    		DNode<E>* v = new DNode<E>;          
		v->elem = e;                         
    		v->next = right_place;
		right_place->prev->next = v;
		v->prev = right_place->prev;
		right_place->prev = v;                          		                              	}

	void remove(DNode<E>* pos) {            // remove from position pos in the list
    		DNode<E>* u = pos->prev;
		DNode<E>* w = pos->next;                
    		u->next = w;
		w->prev = u;                    
    		delete pos;                         
  	}

	// returns a pointer to a node before which elem should be inserted assuming that the list is sorted ascendingly and must remain so. 
	DNode<E>* getRightPlace(const E& e){
		DNode<E>* Cursor = head->next;
		while ((Cursor!=tail)&&(Cursor->elem < e ))
			Cursor = Cursor->next;
		return Cursor;
	}

	void print() {
    		DNode<E>* v = head->next;
    		while (v != tail){
    			cout << v->elem << " ";
    			v = v->next;
   		}
   		cout << endl;
  	}

private: 
	DNode<E>* head;
	DNode<E>* tail; 
};


