#include <iostream>
#include <fstream>
#include "DLinkedList.h"

using namespace std; 


class patient{
public:
	patient(){
	}
	patient(string name, int severity): name_(name), severity_(severity){
	}

	bool operator< (const patient& rhs) const{
		return (severity_ > rhs.severity_);
	}

	bool operator== (const patient& rhs) const{
		return (severity_ == rhs.severity_);
	}

	bool operator> (const patient& rhs) const{
                return !(((*this) < rhs) || ((*this == rhs)));
        }

	bool operator>= (const patient& rhs) const{
		return !((*this) < rhs);
	}

	bool operator<= (const patient& rhs) const{
                return !((*this) > rhs);
        }

	bool operator!= (const patient& rhs) const{
                return !((*this) == rhs);
        }

	friend ostream &operator<<( ostream &output, const patient &p ) { 
        	output << p.name_;
        	return output;            
      	}
	
	/*
	friend bool operator>= (const patient &lhs, const patient &rhs){
        	return !(lhs < rhs);
	}	
	*/	
private:
	string name_;
	int severity_;
};



void sort_string(){
	DLinkedList<string> sorted;	

	string x = "<start>";
        while (x != "<stop>"){
                cin >> x;
		if (x == "<stop>")
			break;
                sorted.add(sorted.getRightPlace(x), x);
		sorted.print();
        }
}

void sort_positive_int(){
	DLinkedList<int> sorted;

	int x=-100;
	while (x != -1){
		cin >> x;
		if (x > 0 ){
			sorted.add(sorted.getRightPlace(x), x);
	                sorted.print();
		}
		cin.clear();
                cin.ignore(1000, '\n');
	}
}

void sort_patients(){
	DLinkedList<patient> sorted;

	ifstream inf;
	inf.open("patients.txt");

	string line;
	while (getline(inf,line)){
		int tab_index = line.find("\t");
		string name = line.substr(0, tab_index);
		int severity = atoi(line.substr(tab_index).c_str());
		patient x(name, severity);
		sorted.add(sorted.getRightPlace(x), x);
                sorted.print();
	}	

	inf.close();
}

int main(){
	cout << "Enter strings to be sorted. Enter <stop> to stop.\n";
	sort_string();
	cout << "Enter positive integers to be sorted. Enter -1 to stop.\n";
	sort_positive_int();
	sort_patients();
	
	return -1;
}

