#include <iostream>
#include <stddef.h>
#include "intSLinkedList.h"

using namespace std;


intSLinkedList::intSLinkedList(): head(NULL) { }

bool intSLinkedList::empty() const{ return head == NULL; }

const int& intSLinkedList::front() const{ return head->elem; }

intSLinkedList::~intSLinkedList(){ while (!empty()) removeFront(); }

void intSLinkedList::addFront(const int& e) {// add to front of list
	intSNode* v = new intSNode;          // create new node
	v->elem = e;                         // store data
    	v->next = head;                      // head now follows v
    	head = v;                            // v is now the head
}

void intSLinkedList::removeFront() {         // remove front item
    	intSNode* old = head;                // save current head
    	head = old->next;                    // skip over old head
    	delete old;                          // delete the old head
}

void intSLinkedList::print() {
    	intSNode* v = head;
    	while (v != NULL){
    		cout << v->elem << " ";
    		v = v->next;
   	}
   	cout << endl;
}

